<template>
  <div>
    <div class="setting-direction-header">
      <div class="setting-direction-header__direction">
        <div
            @click="redirectOnPageSettingDirection"
            class="setting-direction-header__direction-back"
        >
          <i class="icon chevron-left"/> Направления
        </div>
        <div class="setting-direction-header__direction-client">
          <i class="icon role-client"/> {{contractor}}
        </div>
      </div>
      <div
          @click="openModal"
          class="setting-direction-header__delete"
      >
        <i class="icon trash"/> Удалить направление
      </div>
    </div>

    <div class="setting-direction-body">
      <div class="setting-direction-body__path">
        <i class="icon city"/> {{setting.locationStartName}} → <i class="icon city"/> {{setting.locationEndName}}
      </div>

      <div class="setting-direction-body__text">
        <b>Сроки для документов</b>
      </div>

      <div class="setting-direction-body__inputs">
        <ObInput
            v-model="terms.provisionTerm[0].term"
            class="setting-direction-body__inputs-input"
            label="Срок предоставления"
            placeholder="0"
            subTitle="дней"
            type="money:0"
            :isConvertMoney="false"
            @blur="savePersonalTermsByClient({
              ...terms,
              locationStartUuid: setting.locationStartUuid,
              locationEndUuid: setting.locationEndUuid
            })"
        />
        <ObInput
            v-model="terms.executionConfirmationTerm"
            class="setting-direction-body__inputs-input"
            label="Срок проверки исполнения"
            placeholder="0"
            subTitle="дней"
            type="money:0"
            :isConvertMoney="false"
            @blur="savePersonalTermsByClient({
              ...terms,
              locationStartUuid: setting.locationStartUuid,
              locationEndUuid: setting.locationEndUuid
            })"
        />
        <ObInput
            v-model="terms.paymentTerm"
            class="setting-direction-body__inputs-input"
            label="Срок оплаты"
            placeholder="0"
            subTitle="дней"
            type="money:0"
            :isConvertMoney="false"
            @blur="savePersonalTermsByClient({
              ...terms,
              locationStartUuid: setting.locationStartUuid,
              locationEndUuid: setting.locationEndUuid
            })"
        />
      </div>

      <div class="setting-direction-body__text">
        <b>Перечень документов</b>
        <p>Отметьте обязательные документы и их количество. Можете добавить комментарии</p>
      </div>
    </div>

    <ObModal
        ref="delete-modal"
        size="small"
        title="Удалить направление?"
        :is-error="true"
        :is-show-controls="true"
        ok-text="Удалить"
        cancel-text="Отменить"
        @submit="modalDelete(modal_data)"
    >
      <delete-modal :modal_data="modal_data"/>
    </ObModal>

  </div>
</template>

<script>
  import ObInput from "common-components/src/obComponents/obInput";
  import ObModal from "common-components/src/obComponents/obModal";
  import DeleteModal from '../DeleteModal';
  import {mapGetters, mapActions} from "vuex";

  export default {
    name: "SettingDirection",
    components: {
      ObInput,
      ObModal,
      DeleteModal
    },
    data() {
      return {
        modal_data: {}
      }
    },
    computed: {
      ...mapGetters({
        terms: 'clicarSettings/terms',
        setting: 'clicarSettings/personal_direction',
        list_customers: 'clicarSettings/list_customers',
        client_uuid: 'clicarSettings/client_uuid',
        answerByServer: 'clicarSettings/answerByServer'
      }),
      contractor() {
        const contractor = this.list_customers.find(key => key.uuid === this.client_uuid);
        if (contractor.name) {
          return contractor.name;
        }
        return 'Без названия';
      }
    },
    methods: {
      ...mapActions({
        changePersonalDirection: 'clicarSettings/changePersonalDirection',
        redirectOnPageSettingDirection: 'clicarSettings/redirectOnPageSettingDirection',
        savePersonalTermsByClient: 'clicarSettings/savePersonalTermsByClient',
        deleteDirection: 'clicarSettings/deleteDirection'
      }),
      openModal() {
        this.modal_data = {
          ...this.setting,
          contractor: this.contractor
        };
        this.$refs['delete-modal'].open();
      },
      async modalDelete(direction) {
        await this.deleteDirection(direction)
          .then(() => {
            if (this.answerByServer === 'success') {
              this.$notification({
                type: 'system_notification_success',
                message: 'Услугу удалена'
              });
              this.redirectOnPageSettingDirection();
            } else if (this.answerByServer === 'error') {
              this.$notification({
                type: 'system_notification_error',
                message: 'Не удается удалить услугу'
              })
            }
          })
      }
    }
  }
</script>

<style scoped lang="scss">
  .setting-direction {
    &-header {
      display: flex;
      justify-content: space-between;
      align-items: center;
      padding: 20px;
      border-bottom: 1px solid $color-grey-border;
      &__direction {
        display: flex;
        font-size: 16px;
        line-height: 20px;
        letter-spacing: 0.2px;
        cursor: pointer;
        &-back {
          color: $color-blue-navy-blue;
          margin-right: 50px;
          i {
            margin-right: 10px;
          }
        }
        &-client {
          color: $color-text-base;
          text-transform: uppercase;
          i {
            color: $color-blue-navy-blue;
          }
        }
      }
      &__delete {
        font-size: 14px;
        line-height: 16px;
        letter-spacing: 0.2px;
        color: $color-error;
        cursor: pointer;
      }
    }
    &-body {
      padding: 29px 20px;
      &__path {
        font-weight: bold;
        font-size: 20px;
        line-height: 28px;
        letter-spacing: 0.4px;
        margin-bottom: 36px;
        color: $color-text-base;
        i {
          color: $color-blue-navy-blue;
        }
      }
      &__text {
        font-size: 16px;
        line-height: 20px;
        letter-spacing: 0.4px;
        color: $color-text-base;
        padding-bottom: 12px;
        p {
          font-size: 14px;
          line-height: 18px;
          letter-spacing: 0.2px;
          color: $gray-slate;
        }
      }
      &__inputs {
        display: flex;
        margin-bottom: 30px;
        &-input {
          margin-right: 10px;
        }
      }
    }
  }
</style>